# Method: users.watch

Watches for changes in users list.

### HTTP request

`POST https://admin.googleapis.com/admin/directory/v1/users/watch`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Query parameters

| Parameters ||
|---|---|
| `domain` | `string` Name of the domain. Fill this field to get users from only this domain. To return all users in a multi-domain fill customer field instead." |
| `customer` | `string` Immutable ID of the Google Workspace account. In case of multi-domain, to fetch all users for a customer, fill this field instead of domain. |
| `event` | ``enum (`https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/watch#EventType`)`` Events to watch for. |
| `customFieldMask` | `string` Comma-separated list of schema names. All fields from these schemas are fetched. This should only be set when projection=custom. |
| `maxResults` | `integer` Maximum number of results to return. |
| `orderBy` | ``enum (`https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/watch#OrderBy`)`` Column to use for sorting results |
| `pageToken` | `string` Token to specify next page in the list |
| `projection` | ``enum (`https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/watch#Projection`)`` What subset of fields to fetch for this user. |
| `query` | `string` Query string search. Contains one or more search clauses, each with a field, operator, and value. For complete documentation, go to [Search for users](https://developers.google.com/workspace/admin/directory/v1/guides/search-users). |
| `showDeleted` | `string` If set to true, retrieves the list of deleted users. (Default: false) |
| `sortOrder` | ``enum (`https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/watch#SortOrder`)`` Whether to return results in ascending or descending order. |
| `viewType` | ``enum (`https://developers.google.com/workspace/admin/directory/reference/rest/v1/users/watch#ViewType`)`` Whether to fetch the administrator-only or domain-wide public view of the user. For more information, see [Retrieve a user as a non-administrator](https://developers.google.com/workspace/admin/directory/v1/guides/manage-users#retrieve_users_non_admin). |

### Request body

The request body contains an instance of `https://developers.google.com/workspace/admin/directory/reference/rest/v1/SubscriptionChannel`.

### Response body

If successful, the response body contains an instance of `https://developers.google.com/workspace/admin/directory/reference/rest/v1/SubscriptionChannel`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/admin.directory.user`
- `
  https://www.googleapis.com/auth/admin.directory.user.readonly`
- `
  https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authorization guide](https://developers.google.com/workspace/guides/configure-oauth-consent).

## EventType

Type of the Subscription event

| Enums ||
|---|---|
| `ADD` | User Created Event |
| `DELETE` | User Deleted Event |
| `MAKE_ADMIN` | User Admin Status Change Event |
| `UNDELETE` | User Undeleted Event |
| `UPDATE` | User Updated Event |

## OrderBy

| Enums ||
|---|---|
| `EMAIL` | Primary email of the user. |
| `FAMILY_NAME` | User's family name. |
| `GIVEN_NAME` | User's given name. |

## Projection

| Enums ||
|---|---|
| `BASIC` | Do not include any custom fields for the user. |
| `CUSTOM` | Include custom fields from schemas mentioned in customFieldMask. |
| `FULL` | Include all fields associated with this user. |

## SortOrder

| Enums ||
|---|---|
| `ASCENDING` | Ascending order. |
| `DESCENDING` | Descending order. |

## ViewType

| Enums ||
|---|---|
| `admin_view` | Results include both administrator-only and domain-public fields. |
| `domain_public` | Results only include fields for the user that are publicly visible to other users in the domain. |